/* 
    jgaadb - is a simple C++ class library for ODBC databases.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Copyright 2001 - 2002 by Jarle (jgaa) Aase, jgaa@jgaa.com
    http://www.jgaa.com

*/

#ifndef JGAADB_H
#define JGAADB_H

#define BEGIN_JGAADB_NAMESPACE namespace jgaadb {
#define END_JGAADB_NAMESPACE }

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#include "jgaadb_includes.h"

/* Some typedefs */
typedef const char * db_c_str_t;

#include "DbBasicException.h"
#include "DbException.h"
#include "DbColumnDef.h"
#include "DbColumn.h"
#include "DbRecordset.h"
#include "DbTableList.h"
#include "DbConnection.h"
#include "DbCommand.h"

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/

#define JGAADB_VERSION "1.10"

/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

BEGIN_JGAADB_NAMESPACE

/* PROTOTYPES */
void jgaadb_test(const char *dsn);
std::string get_compatible_name(const char *name);


END_JGAADB_NAMESPACE

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* JGAADB_H_ */

