/* 
    jgaadb - is a simple C++ class library for ODBC databases.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Copyright 2001 - 2002 by Jarle (jgaa) Aase, jgaa@jgaa.com
    http://www.jgaa.com

*/

#ifndef JGAADB_SSTREAM_SUBST_H
#define JGAADB_SSTREAM_SUBST_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */


/* LOCAL INCLUDES */


/* FORWARD REFERENCES */


#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

namespace std {
   
class ostringstream 
{
public:
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    ostringstream()
    {}
   
    // OPERATORS
    // OPERATIONS

    void Add(const unsigned char *v)
    {
      mStr += (const char)v;
    }

    void Add(const int v)
    {
      char buf[32];
      sprintf(buf, "%d", v);
      mStr += buf;
    }

   void Add(const unsigned int v)
    {
      char buf[32];
      sprintf(buf, "%u", v);
      mStr += buf;
    }

   void Add(const short v)
    {
      char buf[32];
      sprintf(buf, "%d", v);
      mStr += buf;
    }

   void Add(const unsigned short v)
    {
      char buf[32];
      sprintf(buf, "%u", (int)v);
      mStr += buf;
    }

    template <class classT>
    void Add(const classT& from)
    {
        mStr += from;
    }

    // CALLBACK
    // ACCESS
    // INQUIRY

    const std::string& str() const
    {
        return mStr;
    }
    
protected:
private:
    std::string mStr;
};

template <class classT>
std::ostringstream& operator << (std::ostringstream& o, 
                                 const classT& v)
{
    o.Add(v);
    return o;
}

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

}

#endif  /* JGAADB_SSTREAM_SUBST_H_ */

