/** 
*/

#ifndef JGAADB_BASIC_EXCEPTION_H
#define JGAADB_BASIC_EXCEPTION_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */


/* LOCAL INCLUDES */


/* FORWARD REFERENCES */

BEGIN_JGAADB_NAMESPACE


#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus


class DbBasicException : 
public std::exception
{
public:
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    DbBasicException() 
        : mLine (-1)
    {}

    DbBasicException(const char *why, 
        const char *inFile,
        const int inLine)
        : mFile(inFile), mLine(inLine)
    {
        std::ostringstream buf;
        buf << "Exception from line "
            << mLine
            << " in file \""
            << (mFile ? mFile : "(NULL)")
            << "\": ";

        if (why)
            buf << why;

        mWhy = buf.str();
    }

   
    // OPERATORS
    // OPERATIONS
    // CALLBACK
    // ACCESS
    // INQUIRY

    virtual const char *what() const throw()
    {
        return mWhy.c_str();
    }
    
protected:
    std::string mWhy;
    const char *mFile;
    int mLine;

private:
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */


#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#define DbThrow(why) \
    throw jgaadb::DbBasicException(why, __FILE__, __LINE__)


END_JGAADB_NAMESPACE

#endif  /* JGAADB_BASIC_EXCEPTION_H_ */

